## hidapi 0.8.0~rc1%2Bgit20140818.d17db57%2Bdfsg

=== debian/changelog ===
hidapi (0.8.0~rc1+git20140818.d17db57+dfsg-2) unstable; urgency=medium

  * d/control: Indicate that we're now using a VCS on salsa
  * d/control: Change priority from extra to optional per 4.0.1
  * d/control: Indicate conformance with standards version 4.1.3
  * d/copyright: Change urls to use https
  * d/copyright: Fix spelling error
  * control/rules: Migrate from -dbg to -dbgsym autogenerated packages
  * d/rules: Remove parsing of changelog and use existing variables
  * d/rules: Enable hardening
  * d/rules: Enable dh_strip of libhidapi-dev package
  * d/copyright: Replace license overview with comment to avoid lintian error
  * d/gbp.conf: New file with pristine tar configuration

 -- Scott Talbert <swt@techie.net>  Thu, 22 Feb 2018 00:57:08 -0500

hidapi (0.8.0~rc1+git20140818.d17db57+dfsg-1) unstable; urgency=low

  * Update to latest upstream git commit
  * Removed patches as they have been incorporated upstream
  * Fix watch file
  * Update to latest standards version
  * Update copyright file to eliminate lintian warnings

 -- Scott Talbert <swt@techie.net>  Tue, 03 Nov 2015 20:31:09 -0500

hidapi (0.8.0~rc1+git20140201.3a66d4e+dfsg-3) unstable; urgency=low

  * Add --disable-silent-rules to configuration to make the compile flags
    visible.
  * Reintroduce support for kFreeBSD.

 -- Scott Talbert <swt@techie.net>  Thu, 03 Apr 2014 18:42:07 -0400

hidapi (0.8.0~rc1+git20140201.3a66d4e+dfsg-2) unstable; urgency=low

  * Update copyright date on debian/* files.
  * Include link to bug report for patch.
  * Include HIDAPI license text as a comment in copyright file.

 -- Scott Talbert <swt@techie.net>  Tue, 04 Feb 2014 23:09:37 -0500

hidapi (0.8.0~rc1+git20140201.3a66d4e+dfsg-1) unstable; urgency=low

  * Incorporate patch from Klee Dienes (bump version number to match latest
    GitHub tag, include dfsg in version due to removing non-free files, bump
    standards version, add Files-Excluded listing to copyright file, add
    --parallel to dh command in rules, add watch file).
  * Update license for debian/* to HIDAPI.
  * Add patch to link libhidapi-libusb with pthreads.
  * Added symbols files.
  * Cleanup copyright file to clear lintian warnings.
  * Remove kFreeBSD support for now.

 -- Scott Talbert <swt@techie.net>  Sun, 02 Feb 2014 23:22:26 -0500

hidapi (0.7.0+git20140201.3a66d4e-1) unstable; urgency=low

  * Upgrade to latest upstream version (3a66d4e).
  * Removed special FreeBSD package; FreeBSD now uses libusb package.
  * Clarify/update copyright information (thanks Klee Dienes for patch).
  * Add a get-orig-source to rules which downloads from GitHub, removes
    non-free files, and repacks.

 -- Scott Talbert <swt@techie.net>  Sat, 01 Feb 2014 20:55:58 -0500

hidapi (0.7.0+git20130909.a88c724-1) unstable; urgency=low

  * Initial release (Closes: #724568)

 -- Scott Talbert <swt@techie.net>  Tue, 1 Oct 2013 22:46:00 -0400

## hidapi 0.11.0

=== hidtest/CMakeLists.txt ===
project(hidtest C)

set(HIDAPI_HIDTEST_TARGETS)
if(NOT WIN32 AND NOT APPLE AND CMAKE_SYSTEM_NAME MATCHES "Linux")
    if(TARGET hidapi::hidraw)
        add_executable(hidtest_hidraw test.c)
        target_link_libraries(hidtest_hidraw hidapi::hidraw)
        list(APPEND HIDAPI_HIDTEST_TARGETS hidtest_hidraw)
    endif()
    if(TARGET hidapi::libusb)
        add_executable(hidtest_libusb test.c)
        target_link_libraries(hidtest_libusb hidapi::libusb)
        list(APPEND HIDAPI_HIDTEST_TARGETS hidtest_libusb)
    endif()
else()
    add_executable(hidtest test.c)
    target_link_libraries(hidtest hidapi::hidapi)
    list(APPEND HIDAPI_HIDTEST_TARGETS hidtest)
endif()

install(TARGETS ${HIDAPI_HIDTEST_TARGETS}
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
)

=== src/CMakeLists.txt ===
get_filename_component(PROJECT_ROOT "${CMAKE_CURRENT_LIST_DIR}/.." ABSOLUTE)

# Read version from file
file(READ "${PROJECT_ROOT}/VERSION" RAW_VERSION_STR)
string(REGEX MATCH "^([0-9]+\\.[0-9]+\\.[0-9]+)(.*)" VERSION_STR "${RAW_VERSION_STR}")

if(NOT VERSION_STR)
    message(FATAL_ERROR "Broken VERSION file, couldn't parse '${PROJECT_ROOT}/VERSION' with content: '${RAW_VERSION_STR}'")
endif()

set(VERSION "${CMAKE_MATCH_1}")
string(STRIP "${CMAKE_MATCH_2}" VERSION_SUFFIX)
# compatinility with find_package() vs add_subdirectory
set(hidapi_VERSION "${VERSION}" PARENT_SCOPE)
#

if(DEFINED HIDAPI_PRINT_VERSION AND HIDAPI_PRINT_VERSION)
    set(HIDAPI_PRINT_VERSION "hidapi: v${VERSION}")
    if(VERSION_SUFFIX)
        set(HIDAPI_PRINT_VERSION "${HIDAPI_PRINT_VERSION} (${VERSION_SUFFIX})")
    endif()
    message(STATUS "${HIDAPI_PRINT_VERSION}")
endif()

project(hidapi VERSION "${VERSION}" LANGUAGES C)

# Defaults and required options

if(NOT DEFINED BUILD_SHARED_LIBS)
    set(BUILD_SHARED_LIBS ON)
endif()
if(NOT DEFINED HIDAPI_INSTALL_TARGETS)
    set(HIDAPI_INSTALL_TARGETS OFF)
endif()
if(NOT DEFINED CMAKE_POSITION_INDEPENDENT_CODE)
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
endif()

get_directory_property(IS_EXCLUDE_FROM_ALL EXCLUDE_FROM_ALL)
if(IS_EXCLUDE_FROM_ALL)
    if(HIDAPI_INSTALL_TARGETS)
        message(WARNING "Installing EXCLUDE_FROM_ALL targets in an undefined behavior in CMake.\nDon't add 'hidapi' sundirectory with 'EXCLUDE_FROM_ALL' property, or don't set 'HIDAPI_INSTALL_TARGETS' to TRUE.")
    endif()
endif()

# Helper(s)

function(hidapi_configure_pc PC_IN_FILE)
    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/pc")

    set(VERSION "${VERSION}${VERSION_SUFFIX}")
    set(prefix "${CMAKE_INSTALL_PREFIX}")
    set(exec_prefix "\${prefix}")
    if(IS_ABSOLUTE "${CMAKE_INSTALL_LIBDIR}")
        set(libdir "${CMAKE_INSTALL_LIBDIR}")
    else()
        set(libdir "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
    endif()
    if(IS_ABSOLUTE "${CMAKE_INSTALL_INCLUDEDIR}")
        set(includedir "${CMAKE_INSTALL_INCLUDEDIR}")
    else()
        set(includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
    endif()

    get_filename_component(PC_IN_FILENAME "${PC_IN_FILE}" NAME_WE)
    set(PC_FILE "${CMAKE_CURRENT_BINARY_DIR}/pc/${PC_IN_FILENAME}.pc")
    configure_file("${PC_IN_FILE}" "${PC_FILE}" @ONLY)

    install(FILES "${PC_FILE}" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig/")
endfunction()

# The library

add_library(hidapi_include INTERFACE)
target_include_directories(hidapi_include INTERFACE
    "$<BUILD_INTERFACE:${PROJECT_ROOT}/hidapi>"
    "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/hidapi>"
)
set_target_properties(hidapi_include PROPERTIES EXPORT_NAME "include")
set(HIDAPI_PUBLIC_HEADERS "${PROJECT_ROOT}/hidapi/hidapi.h")

add_library(hidapi::include ALIAS hidapi_include)

if(HIDAPI_INSTALL_TARGETS)
    include(GNUInstallDirs)
    install(TARGETS hidapi_include EXPORT hidapi)
endif()

set(EXPORT_ALIAS)
set(EXPORT_COMPONENTS)

set(HIDAPI_NEED_EXPORT_THREADS FALSE)
set(HIDAPI_NEED_EXPORT_LIBUSB FALSE)
set(HIDAPI_NEED_EXPORT_LIBUDEV FALSE)

if(WIN32)
    add_subdirectory("${PROJECT_ROOT}/windows" windows)
    set(EXPORT_ALIAS winapi)
    list(APPEND EXPORT_COMPONENTS winapi)
elseif(APPLE)
    add_subdirectory("${PROJECT_ROOT}/mac" mac)
    set(EXPORT_ALIAS darwin)
    list(APPEND EXPORT_COMPONENTS darwin)
    if(NOT BUILD_SHARED_LIBS)
        set(HIDAPI_NEED_EXPORT_THREADS TRUE)
    endif()
else()
    if(NOT DEFINED HIDAPI_WITH_LIBUSB)
        set(HIDAPI_WITH_LIBUSB ON)
    endif()
    if(CMAKE_SYSTEM_NAME MATCHES "Linux")
        if(NOT DEFINED HIDAPI_WITH_HIDRAW)
            set(HIDAPI_WITH_HIDRAW ON)
        endif()
        if(HIDAPI_WITH_HIDRAW)
            add_subdirectory("${PROJECT_ROOT}/linux" linux)
            list(APPEND EXPORT_COMPONENTS hidraw)
            set(EXPORT_ALIAS hidraw)
            if(NOT BUILD_SHARED_LIBS)
                set(HIDAPI_NEED_EXPORT_THREADS TRUE)
                set(HIDAPI_NEED_EXPORT_LIBUDEV TRUE)
            endif()
        endif()
    else()
        set(HIDAPI_WITH_LIBUSB ON)
    endif()
    if(HIDAPI_WITH_LIBUSB)
        target_include_directories(hidapi_include INTERFACE
            "$<BUILD_INTERFACE:${PROJECT_ROOT}/libusb>"
        )
        add_subdirectory("${PROJECT_ROOT}/libusb" libusb)
        list(APPEND EXPORT_COMPONENTS libusb)
        if(NOT EXPORT_ALIAS)
            set(EXPORT_ALIAS libusb)
        endif()
        if(NOT BUILD_SHARED_LIBS)
            set(HIDAPI_NEED_EXPORT_THREADS TRUE)
            if(NOT TARGET usb-1.0)
                set(HIDAPI_NEED_EXPORT_LIBUSB TRUE)
            endif()
        endif()
    elseif(NOT TARGET hidapi_hidraw)
        message(FATAL_ERROR "Select at least one option to build: HIDAPI_WITH_LIBUSB or HIDAPI_WITH_HIDRAW")
    endif()
endif()

add_library(hidapi::hidapi ALIAS hidapi_${EXPORT_ALIAS})

if(HIDAPI_INSTALL_TARGETS)
    include(CMakePackageConfigHelpers)
    set(EXPORT_DENERATED_LOCATION "${CMAKE_BINARY_DIR}/export_generated")
    set(EXPORT_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/hidapi")
    write_basic_package_version_file("${EXPORT_DENERATED_LOCATION}/hidapi-config-version.cmake"
        COMPATIBILITY SameMajorVersion
    )
    configure_package_config_file("cmake/hidapi-config.cmake.in" "${EXPORT_DENERATED_LOCATION}/hidapi-config.cmake"
        INSTALL_DESTINATION "${EXPORT_DESTINATION}"
        NO_SET_AND_CHECK_MACRO
    )

    install(EXPORT hidapi
        DESTINATION "${EXPORT_DESTINATION}"
        NAMESPACE hidapi::
    )
    install(FILES
            "${EXPORT_DENERATED_LOCATION}/hidapi-config-version.cmake"
            "${EXPORT_DENERATED_LOCATION}/hidapi-config.cmake"
        DESTINATION "${EXPORT_DESTINATION}"
    )
endif()

## hidapi 0.8.0~rc1+git20140201.3a66d4e+dfsg

=== debian/control ===
Source: hidapi
Priority: extra
Maintainer: Scott Talbert <swt@techie.net>
Build-Depends: debhelper (>= 9), dh-autoreconf, libudev-dev [linux-any], libusb-1.0-0-dev [linux-any], libusb2-dev (>= 10.0-4) [kfreebsd-any], pkg-config
Standards-Version: 3.9.5
Section: libs
Homepage: http://www.signal11.us/oss/hidapi/

Package: libhidapi-dev
Section: libdevel
Architecture: kfreebsd-any linux-any
Multi-Arch: same
Depends: ${misc:Depends}, libhidapi0 (= ${binary:Version}) [kfreebsd-any], libhidapi-libusb0 (= ${binary:Version}) [linux-any], libhidapi-hidraw0 (= ${binary:Version}) [linux-any]
Description: Multi-Platform library for communication with HID devices (development files)
 HIDAPI is a multi-platform library enabling applications to easily
 interface with Bluetooth and USB HID-class devices.
 .
 This package contains the files needed to compile and link programs which
 use HIDAPI.

Package: libhidapi0
Architecture: kfreebsd-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Multi-Platform library for communication with HID devices
 HIDAPI is a multi-platform library enabling applications to easily
 interface with Bluetooth and USB HID-class devices.
 .
 This package contains the files needed to run programs which use HIDAPI.

Package: libhidapi-libusb0
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Multi-Platform library for communication with HID devices (libusb backend)
 HIDAPI is a multi-platform library enabling applications to easily
 interface with Bluetooth and USB HID-class devices.
 .
 This package contains the libusb-based implementation of HIDAPI.

Package: libhidapi-hidraw0
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Multi-Platform library for communication with HID devices (hidraw backend)
 HIDAPI is a multi-platform library enabling applications to easily
 interface with Bluetooth and USB HID-class devices.
 .
 This package contains the hidraw-based implementation of HIDAPI.

Package: libhidapi0-dbg
Architecture: kfreebsd-any
Multi-Arch: same
Section: debug
Depends: libhidapi0 (= ${binary:Version}), ${misc:Depends}
Description: Debugging symbols for libhidapi0
 HIDAPI is a multi-platform library enabling applications to easily
 interface with Bluetooth and USB HID-class devices.
 .
 This package contains the debugging symbols for libhidapi0.

Package: libhidapi-libusb0-dbg
Architecture: linux-any
Multi-Arch: same
Section: debug
Depends: libhidapi-libusb0 (= ${binary:Version}), ${misc:Depends}
Description: Debugging symbols for libhidapi-libusb0
 HIDAPI is a multi-platform library enabling applications to easily
 interface with Bluetooth and USB HID-class devices.
 .
 This package contains the debugging symbols for libhidapi-libusb0.

Package: libhidapi-hidraw0-dbg
Architecture: linux-any
Multi-Arch: same
Section: debug
Depends: libhidapi-hidraw0 (= ${binary:Version}), ${misc:Depends}
Description: Debugging symbols for libhidapi-hidraw0
 HIDAPI is a multi-platform library enabling applications to easily
 interface with Bluetooth and USB HID-class devices.
 .
 This package contains the debugging symbols for libhidapi-hidraw0.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --disable-silent-rules

override_dh_strip:
ifeq ($(DEB_HOST_ARCH_OS), linux)
	dh_strip -plibhidapi-libusb0 --dbg-package=libhidapi-libusb0-dbg
	dh_strip -plibhidapi-hidraw0 --dbg-package=libhidapi-hidraw0-dbg
endif
ifeq ($(DEB_HOST_ARCH_OS), kfreebsd)
	dh_strip -plibhidapi0 --dbg-package=libhidapi0-dbg
endif

COMMIT := 3a66d4e513ed1b1ce82b7e6fcfa30ff05598b696
TMPTAR := hidapi.tar.gz
DEBVER := $(shell dpkg-parsechangelog | grep ^Version: | cut -d' ' -f2 \
	| cut -d- -f1)

# Download source from GitHub, remove non-free files, and repack in Deb format
get-orig-source:
	wget -q https://github.com/signal11/hidapi/archive/$(COMMIT)/$(TMPTAR)
	tar zxf $(TMPTAR)
	rm $(TMPTAR)
	rm hidapi-$(COMMIT)/windows/ddk_build/makefile
	rm hidapi-$(COMMIT)/testgui/mac_support.cpp
	mv hidapi-$(COMMIT) hidapi-$(DEBVER)
	tar cf hidapi_$(DEBVER).orig.tar hidapi-$(DEBVER)
	rm -r hidapi-$(DEBVER)
	bzip2 -9 hidapi_$(DEBVER).orig.tar

=== debian/watch ===
version=3
opts="uversionmangle=s/\.?-rc/~rc/,dversionmangle=s/\.dfsg//" \
http://githubredir.debian.net/githubredir.cgi?author=signal11&project=hidapi .*hidapi-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## hidapi 0.8.0~rc1+git20140818.d17db57+dfsg

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: extra
 Maintainer: Scott Talbert <swt@techie.net>
 Build-Depends: debhelper (>= 9), dh-autoreconf, libudev-dev [linux-any], libusb-1.0-0-dev [linux-any], libusb2-dev (>= 10.0-4) [kfreebsd-any], pkg-config
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Section: libs
 Homepage: http://www.signal11.us/oss/hidapi/

=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,7 @@
 	dh_strip -plibhidapi0 --dbg-package=libhidapi0-dbg
 endif
 
-COMMIT := 3a66d4e513ed1b1ce82b7e6fcfa30ff05598b696
+COMMIT := d17db57b9d4354752e0af42f5f33007a42ef2906
 TMPTAR := hidapi.tar.gz
 DEBVER := $(shell dpkg-parsechangelog | grep ^Version: | cut -d' ' -f2 \
 	| cut -d- -f1)

=== debian/watch ===
version=3
opts="uversionmangle=s/\.?-rc/~rc/,dversionmangle=s/\+.*dfsg$//,filenamemangle=s/.+\/?(\d\S*)\.tar\.gz/hidapi-$1\.tar\.gz/" \
https://github.com/signal11/hidapi/tags .*/hidapi-?(\d\S*)\.tar\.gz

## hidapi 0.9.0+dfsg

=== debian/changelog ===
hidapi (0.9.0+dfsg-1) unstable; urgency=medium

  * Switch to new upstream at libusb organization (Closes: #931035)
  * Update to new upstream release 0.9.0
  * d/control: Update debhelper compat version to 12
  * d/control: Update Standards Version to 4.4.0 (no changes needed)
  * d/rules: Remove get-orig-source (repacking performed by uscan now)
  * d/rules: Remove dbgsym-migration since it was part of buster release
  * d/*.symbols: Add Build-Depends-Package fields
  * d/rules: Remove --parallel from dh invocation (default in dh 12)
  * d/control: Remove autoreconf from deps (not needed in dh 12)

 -- Scott Talbert <swt@techie.net>  Thu, 11 Jul 2019 19:26:46 -0400

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,12 @@
 Source: hidapi
-Priority: extra
+Priority: optional
 Maintainer: Scott Talbert <swt@techie.net>
-Build-Depends: debhelper (>= 9), dh-autoreconf, libudev-dev [linux-any], libusb-1.0-0-dev [linux-any], libusb2-dev (>= 10.0-4) [kfreebsd-any], pkg-config
-Standards-Version: 3.9.6
+Build-Depends: debhelper (>= 12), libudev-dev [linux-any], libusb-1.0-0-dev [linux-any], libusb2-dev (>= 10.0-4) [kfreebsd-any], pkg-config
+Standards-Version: 4.4.0
 Section: libs
-Homepage: http://www.signal11.us/oss/hidapi/
+Homepage: https://github.com/libusb/hidapi
+Vcs-Git: https://salsa.debian.org/debian/hidapi.git
+Vcs-Browser: https://salsa.debian.org/debian/hidapi
 
 Package: libhidapi-dev
 Section: libdevel
@@ -50,37 +52,3 @@
  interface with Bluetooth and USB HID-class devices.
  .
  This package contains the hidraw-based implementation of HIDAPI.
-
-Package: libhidapi0-dbg
-Architecture: kfreebsd-any
-Multi-Arch: same
-Section: debug
-Depends: libhidapi0 (= ${binary:Version}), ${misc:Depends}
-Description: Debugging symbols for libhidapi0
- HIDAPI is a multi-platform library enabling applications to easily
- interface with Bluetooth and USB HID-class devices.
- .
- This package contains the debugging symbols for libhidapi0.
-
-Package: libhidapi-libusb0-dbg
-Architecture: linux-any
-Multi-Arch: same
-Section: debug
-Depends: libhidapi-libusb0 (= ${binary:Version}), ${misc:Depends}
-Description: Debugging symbols for libhidapi-libusb0
- HIDAPI is a multi-platform library enabling applications to easily
- interface with Bluetooth and USB HID-class devices.
- .
- This package contains the debugging symbols for libhidapi-libusb0.
-
-Package: libhidapi-hidraw0-dbg
-Architecture: linux-any
-Multi-Arch: same
-Section: debug
-Depends: libhidapi-hidraw0 (= ${binary:Version}), ${misc:Depends}
-Description: Debugging symbols for libhidapi-hidraw0
- HIDAPI is a multi-platform library enabling applications to easily
- interface with Bluetooth and USB HID-class devices.
- .
- This package contains the debugging symbols for libhidapi-hidraw0.
-

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --disable-silent-rules

override_dh_strip:
	dh_strip -plibhidapi-dev
ifeq ($(DEB_HOST_ARCH_OS), linux)
	dh_strip -plibhidapi-libusb0
	dh_strip -plibhidapi-hidraw0
endif
ifeq ($(DEB_HOST_ARCH_OS), kfreebsd)
	dh_strip -plibhidapi0
endif

=== debian/watch ===
version=4
opts="uversionmangle=s/\.?-rc/~rc/,dversionmangle=s/\+.*dfsg$//,filenamemangle=s/.+\/?(\d\S*)\.tar\.gz/hidapi-$1\.tar\.gz/,repacksuffix=+dfsg,compression=xz" \
https://github.com/libusb/hidapi/tags .*/hidapi-?(\d\S*)\.tar\.gz

## hidapi 0.10.0+dfsg

=== debian/changelog ===
hidapi (0.10.0+dfsg-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set debhelper-compat version in Build-Depends.
  * debian/copyright: use spaces rather than tabs to start continuation
    lines.
  * Drop unnecessary dependency on dh-autoreconf.

  [ Scott Talbert ]
  * Remove unnecessary filename mangling in d/watch
  * Remove no longer existing file from d/copyright Files-Excluded
  * Update to new upstream release 0.10.0
  * Update standards version to 4.5.0, no changes needed
  * Update d/copyright to reflect file renaming
  * Rules-Requires-Root: no
  * Update symbols files for 0.10.0 release
  * Add a debian/not-installed file to specify non-installed files
  * Update to debhelper compat level 13

 -- Scott Talbert <swt@techie.net>  Sun, 01 Nov 2020 23:06:57 -0500

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: hidapi
 Priority: optional
 Maintainer: Scott Talbert <swt@techie.net>
-Build-Depends: debhelper (>= 12), libudev-dev [linux-any], libusb-1.0-0-dev [linux-any], libusb2-dev (>= 10.0-4) [kfreebsd-any], pkg-config
-Standards-Version: 4.4.0
+Build-Depends: debhelper-compat (= 13), libudev-dev [linux-any], libusb-1.0-0-dev [linux-any], libusb2-dev (>= 10.0-4) [kfreebsd-any], pkg-config
+Standards-Version: 4.5.0
 Section: libs
 Homepage: https://github.com/libusb/hidapi
 Vcs-Git: https://salsa.debian.org/debian/hidapi.git
 Vcs-Browser: https://salsa.debian.org/debian/hidapi
+Rules-Requires-Root: no
 
 Package: libhidapi-dev
 Section: libdevel

## hidapi 0.10.1%2Bdfsg

=== debian/watch ===
version=4
opts="uversionmangle=s/\.?-rc/~rc/,dversionmangle=s/\+.*dfsg$//,repacksuffix=+dfsg,compression=xz" \
https://github.com/libusb/hidapi/tags .*/hidapi-?(\d\S*)\.tar\.gz

## hidapi 0.10.1+dfsg

=== debian/changelog ===
hidapi (0.10.1+dfsg-1) unstable; urgency=medium

  * Update to new upstream release 0.10.1
  * Update standards version to 4.5.1, no changes needed
  * Fix FTBFS with autoconf 2.70 (Closes: #978834)

 -- Scott Talbert <swt@techie.net>  Thu, 31 Dec 2020 15:08:13 -0500

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Scott Talbert <swt@techie.net>
 Build-Depends: debhelper-compat (= 13), libudev-dev [linux-any], libusb-1.0-0-dev [linux-any], libusb2-dev (>= 10.0-4) [kfreebsd-any], pkg-config
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Section: libs
 Homepage: https://github.com/libusb/hidapi
 Vcs-Git: https://salsa.debian.org/debian/hidapi.git

## hidapi 0.11.0

=== debian/changelog ===
hidapi (0.11.0-1~mx21+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Wed, 01 Dec 2021 09:04:32 -0500

hidapi (0.11.0-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Scott Talbert ]
  * Remove repacking as non-DFSG files removed upstream
  * Update to new upstream release 0.11.0
  * Update Standards-Version to 4.6.0 (no changes needed)

 -- Scott Talbert <swt@techie.net>  Thu, 07 Oct 2021 15:17:10 -0400

=== debian/rules ===
--- 
+++ 
@@ -3,12 +3,13 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
-	dh $@ --with autoreconf
+	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- --disable-silent-rules
 
 override_dh_strip:
+	dh_strip --no-automatic-dbgsym
 	dh_strip -plibhidapi-dev
 ifeq ($(DEB_HOST_ARCH_OS), linux)
 	dh_strip -plibhidapi-libusb0

## hidapi 0.11.2

=== libusb/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6.3 FATAL_ERROR)

list(APPEND HIDAPI_PUBLIC_HEADERS "hidapi_libusb.h")

add_library(hidapi_libusb
    ${HIDAPI_PUBLIC_HEADERS}
    hid.c
)
target_link_libraries(hidapi_libusb PUBLIC hidapi_include)

if(TARGET usb-1.0)
    target_link_libraries(hidapi_libusb PRIVATE usb-1.0)
else()
    include(FindPkgConfig)
    pkg_check_modules(libusb REQUIRED IMPORTED_TARGET libusb-1.0>=1.0.9)
    target_link_libraries(hidapi_libusb PRIVATE PkgConfig::libusb)
endif()

find_package(Threads REQUIRED)
target_link_libraries(hidapi_libusb PRIVATE Threads::Threads)

set_target_properties(hidapi_libusb
    PROPERTIES
        EXPORT_NAME "libusb"
        OUTPUT_NAME "hidapi-libusb"
        VERSION ${PROJECT_VERSION}
        SOVERSION ${PROJECT_VERSION_MAJOR}
        PUBLIC_HEADER "${HIDAPI_PUBLIC_HEADERS}"
)

# compatibility with find_package()
add_library(hidapi::libusb ALIAS hidapi_libusb)
# compatibility with raw library link
add_library(hidapi-libusb ALIAS hidapi_libusb)

if(HIDAPI_INSTALL_TARGETS)
    install(TARGETS hidapi_libusb EXPORT hidapi
        LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/hidapi"
    )
endif()

hidapi_configure_pc("${PROJECT_ROOT}/pc/hidapi-libusb.pc.in")

=== linux/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6.3 FATAL_ERROR)

add_library(hidapi_hidraw
    ${HIDAPI_PUBLIC_HEADERS}
    hid.c
)
target_link_libraries(hidapi_hidraw PUBLIC hidapi_include)

find_package(Threads REQUIRED)

include(FindPkgConfig)
pkg_check_modules(libudev REQUIRED IMPORTED_TARGET libudev)

target_link_libraries(hidapi_hidraw PRIVATE PkgConfig::libudev Threads::Threads)

set_target_properties(hidapi_hidraw
    PROPERTIES
        EXPORT_NAME "hidraw"
        OUTPUT_NAME "hidapi-hidraw"
        VERSION ${PROJECT_VERSION}
        SOVERSION ${PROJECT_VERSION_MAJOR}
        PUBLIC_HEADER "${HIDAPI_PUBLIC_HEADERS}"
)

# compatibility with find_package()
add_library(hidapi::hidraw ALIAS hidapi_hidraw)
# compatibility with raw library link
add_library(hidapi-hidraw ALIAS hidapi_hidraw)

if(HIDAPI_INSTALL_TARGETS)
    install(TARGETS hidapi_hidraw EXPORT hidapi
        LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/hidapi"
    )
endif()

hidapi_configure_pc("${PROJECT_ROOT}/pc/hidapi-hidraw.pc.in")

=== mac/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4.3 FATAL_ERROR)

add_library(hidapi_darwin
    ${HIDAPI_PUBLIC_HEADERS}
    hid.c
)

find_package(Threads REQUIRED)

target_link_libraries(hidapi_darwin
    PUBLIC hidapi_include
    PRIVATE Threads::Threads
    PRIVATE "-framework IOKit" "-framework CoreFoundation" "-framework AppKit"
)

set_target_properties(hidapi_darwin
    PROPERTIES
        EXPORT_NAME "darwin"
        OUTPUT_NAME "hidapi"
        VERSION ${PROJECT_VERSION}
        SOVERSION ${PROJECT_VERSION_MAJOR}
        MACHO_COMPATIBILITY_VERSION ${PROJECT_VERSION_MAJOR}
        FRAMEWORK_VERSION ${PROJECT_VERSION_MAJOR}
        PUBLIC_HEADER "${HIDAPI_PUBLIC_HEADERS}"
)

# compatibility with find_package()
add_library(hidapi::darwin ALIAS hidapi_darwin)
# compatibility with raw library link
add_library(hidapi ALIAS hidapi_darwin)

set(PUBLIC_HEADER_DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
if(NOT CMAKE_FRAMEWORK)
    set(PUBLIC_HEADER_DESTINATION "${PUBLIC_HEADER_DESTINATION}/hidapi")
endif()

if(HIDAPI_INSTALL_TARGETS)
    install(TARGETS hidapi_darwin EXPORT hidapi
        LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        FRAMEWORK DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        PUBLIC_HEADER DESTINATION "${PUBLIC_HEADER_DESTINATION}"
    )
endif()

hidapi_configure_pc("${PROJECT_ROOT}/pc/hidapi.pc.in")

=== windows/CMakeLists.txt ===
add_library(hidapi_winapi
    ${HIDAPI_PUBLIC_HEADERS}
    hid.c
)
target_link_libraries(hidapi_winapi
    PUBLIC hidapi_include
    PRIVATE setupapi
)

set_target_properties(hidapi_winapi
    PROPERTIES
        EXPORT_NAME "winapi"
        OUTPUT_NAME "hidapi"
        VERSION ${PROJECT_VERSION}
        PUBLIC_HEADER "${HIDAPI_PUBLIC_HEADERS}"
)

# compatibility with find_package()
add_library(hidapi::winapi ALIAS hidapi_winapi)
# compatibility with raw library link
add_library(hidapi ALIAS hidapi_winapi)

if(HIDAPI_INSTALL_TARGETS)
    install(TARGETS hidapi_winapi EXPORT hidapi
        RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
        LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/hidapi"
    )
endif()

hidapi_configure_pc("${PROJECT_ROOT}/pc/hidapi.pc.in")

=== debian/changelog ===
hidapi (0.11.2-1) unstable; urgency=medium

  * Update to new upstream release 0.11.2

 -- Scott Talbert <swt@techie.net>  Mon, 14 Feb 2022 19:17:50 -0500

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Scott Talbert <swt@techie.net>
 Build-Depends: debhelper-compat (= 13), libudev-dev [linux-any], libusb-1.0-0-dev [linux-any], libusb2-dev (>= 10.0-4) [kfreebsd-any], pkg-config
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Section: libs
 Homepage: https://github.com/libusb/hidapi
 Vcs-Git: https://salsa.debian.org/debian/hidapi.git

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,6 @@
 	dh_auto_configure -- --disable-silent-rules
 
 override_dh_strip:
-	dh_strip --no-automatic-dbgsym
 	dh_strip -plibhidapi-dev
 ifeq ($(DEB_HOST_ARCH_OS), linux)
 	dh_strip -plibhidapi-libusb0

## hidapi 0.12.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -92,12 +92,19 @@
 set(HIDAPI_NEED_EXPORT_THREADS FALSE)
 set(HIDAPI_NEED_EXPORT_LIBUSB FALSE)
 set(HIDAPI_NEED_EXPORT_LIBUDEV FALSE)
+set(HIDAPI_NEED_EXPORT_ICONV FALSE)
 
 if(WIN32)
+    target_include_directories(hidapi_include INTERFACE
+        "$<BUILD_INTERFACE:${PROJECT_ROOT}/windows>"
+    )
     add_subdirectory("${PROJECT_ROOT}/windows" windows)
     set(EXPORT_ALIAS winapi)
     list(APPEND EXPORT_COMPONENTS winapi)
 elseif(APPLE)
+    target_include_directories(hidapi_include INTERFACE
+        "$<BUILD_INTERFACE:${PROJECT_ROOT}/mac>"
+    )
     add_subdirectory("${PROJECT_ROOT}/mac" mac)
     set(EXPORT_ALIAS darwin)
     list(APPEND EXPORT_COMPONENTS darwin)
@@ -128,6 +135,9 @@
         target_include_directories(hidapi_include INTERFACE
             "$<BUILD_INTERFACE:${PROJECT_ROOT}/libusb>"
         )
+        if(NOT DEFINED HIDAPI_NO_ICONV)
+            set(HIDAPI_NO_ICONV OFF)
+        endif()
         add_subdirectory("${PROJECT_ROOT}/libusb" libusb)
         list(APPEND EXPORT_COMPONENTS libusb)
         if(NOT EXPORT_ALIAS)
@@ -137,6 +147,9 @@
             set(HIDAPI_NEED_EXPORT_THREADS TRUE)
             if(NOT TARGET usb-1.0)
                 set(HIDAPI_NEED_EXPORT_LIBUSB TRUE)
+            endif()
+            if(NOT HIDAPI_NO_ICONV AND NOT ANDROID AND NOT CMAKE_VERSION VERSION_LESS 3.11)
+                set(HIDAPI_NEED_EXPORT_ICONV TRUE)
             endif()
         endif()
     elseif(NOT TARGET hidapi_hidraw)
@@ -150,7 +163,7 @@
     include(CMakePackageConfigHelpers)
     set(EXPORT_DENERATED_LOCATION "${CMAKE_BINARY_DIR}/export_generated")
     set(EXPORT_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/hidapi")
-    write_basic_package_version_file("${EXPORT_DENERATED_LOCATION}/hidapi-config-version.cmake"
+    write_basic_package_version_file("${EXPORT_DENERATED_LOCATION}/libhidapi-version.cmake"
         COMPATIBILITY SameMajorVersion
     )
     configure_package_config_file("cmake/hidapi-config.cmake.in" "${EXPORT_DENERATED_LOCATION}/hidapi-config.cmake"
@@ -161,9 +174,10 @@
     install(EXPORT hidapi
         DESTINATION "${EXPORT_DESTINATION}"
         NAMESPACE hidapi::
+        FILE "libhidapi.cmake"
     )
     install(FILES
-            "${EXPORT_DENERATED_LOCATION}/hidapi-config-version.cmake"
+            "${EXPORT_DENERATED_LOCATION}/libhidapi-version.cmake"
             "${EXPORT_DENERATED_LOCATION}/hidapi-config.cmake"
         DESTINATION "${EXPORT_DESTINATION}"
     )

=== windows/CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,23 @@
+list(APPEND HIDAPI_PUBLIC_HEADERS "hidapi_winapi.h")
+
+set(SOURCES
+    hid.c
+    hidapi_cfgmgr32.h
+    hidapi_hidclass.h
+    hidapi_hidpi.h
+    hidapi_hidsdi.h
+)
+
+if(BUILD_SHARED_LIBS)
+    list(APPEND SOURCES hidapi.rc)
+endif()
+
 add_library(hidapi_winapi
     ${HIDAPI_PUBLIC_HEADERS}
-    hid.c
+    ${SOURCES}
 )
 target_link_libraries(hidapi_winapi
     PUBLIC hidapi_include
-    PRIVATE setupapi
 )
 
 set_target_properties(hidapi_winapi

=== debian/changelog ===
hidapi (0.12.0-1) unstable; urgency=medium

  * Update to new upstream release 0.12.0
  * Update Standards-Version to 4.6.1

 -- Scott Talbert <swt@techie.net>  Tue, 02 Aug 2022 23:21:16 -0400

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Scott Talbert <swt@techie.net>
 Build-Depends: debhelper-compat (= 13), libudev-dev [linux-any], libusb-1.0-0-dev [linux-any], libusb2-dev (>= 10.0-4) [kfreebsd-any], pkg-config
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Section: libs
 Homepage: https://github.com/libusb/hidapi
 Vcs-Git: https://salsa.debian.org/debian/hidapi.git

## hidapi 0.13.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3 FATAL_ERROR)

if(NOT CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    add_subdirectory(src)
    # compatinility with find_package() vs add_subdirectory
    set(hidapi_VERSION "${hidapi_VERSION}" PARENT_SCOPE)
    return()
endif()
# All of the below in this file is meant for a standalone build.
# When building as a subdirectory of a larger project, most of the options may not make sense for it,
# so it is up to developer to configure those, e.g.:
#
# # a subfolder of a master project, e.g.: 3rdparty/hidapi/CMakeLists.txt
#
# set(HIDAPI_WITH_HIDRAW OFF)
# set(CMAKE_FRAMEWORK ON)
# # and keep everything else to their defaults
# add_subdirectory(hidapi)
#

set(DEFAULT_CMAKE_BUILD_TYPES "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
if(NOT DEFINED CMAKE_BUILD_TYPE OR NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "${DEFAULT_CMAKE_BUILD_TYPES}" FORCE)
endif()
# This part is for convenience, when used one of the standard build types with cmake-gui
list(FIND DEFAULT_CMAKE_BUILD_TYPES "${CMAKE_BUILD_TYPE}" _build_type_index)
if(${_build_type_index} GREATER -1)
    # set it optionally, so a custom CMAKE_BUILD_TYPE can be used as well, if needed
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS ${DEFAULT_CMAKE_BUILD_TYPES})
endif()
unset(_build_type_index)
#

project(hidapi LANGUAGES C)

if(APPLE)
    if(NOT CMAKE_VERSION VERSION_LESS "3.15")
        option(CMAKE_FRAMEWORK "Build macOS/iOS Framework version of the library" OFF)
    endif()
elseif(NOT WIN32)
    if(CMAKE_SYSTEM_NAME MATCHES "Linux")
        option(HIDAPI_WITH_HIDRAW "Build HIDRAW-based implementation of HIDAPI" ON)
        option(HIDAPI_WITH_LIBUSB "Build LIBUSB-based implementation of HIDAPI" ON)
    endif()
endif()

option(BUILD_SHARED_LIBS "Build shared version of the libraries, otherwise build statically" ON)

set(HIDAPI_INSTALL_TARGETS ON)
set(HIDAPI_PRINT_VERSION ON)

add_subdirectory(src)

set(BUILD_HIDTEST_DEFAULT OFF)
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(BUILD_HIDTEST_DEFAULT ON)
endif()
option(HIDAPI_BUILD_HIDTEST "Build small console test application hidtest" ${BUILD_HIDTEST_DEFAULT})
if(HIDAPI_BUILD_HIDTEST)
    add_subdirectory(hidtest)
endif()

=== hidtest/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,20 @@
+cmake_minimum_required(VERSION 3.1.3 FATAL_ERROR)
 project(hidtest C)
+
+if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
+    # hidtest is build as a standalone project
+
+    if(POLICY CMP0074)
+        # allow using hidapi_ROOT if CMake supports it
+        cmake_policy(SET CMP0074 NEW)
+    endif()
+
+    find_package(hidapi 0.12 REQUIRED)
+    message(STATUS "Using HIDAPI: ${hidapi_VERSION}")
+else()
+    # hidtest is built as part of the main HIDAPI build
+    message(STATUS "Building hidtest")
+endif()
 
 set(HIDAPI_HIDTEST_TARGETS)
 if(NOT WIN32 AND NOT APPLE AND CMAKE_SYSTEM_NAME MATCHES "Linux")
@@ -9,6 +25,7 @@
     endif()
     if(TARGET hidapi::libusb)
         add_executable(hidtest_libusb test.c)
+        target_compile_definitions(hidtest_libusb PRIVATE USING_HIDAPI_LIBUSB)
         target_link_libraries(hidtest_libusb hidapi::libusb)
         list(APPEND HIDAPI_HIDTEST_TARGETS hidtest_libusb)
     endif()

=== mac/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,6 @@
 cmake_minimum_required(VERSION 3.4.3 FATAL_ERROR)
+
+list(APPEND HIDAPI_PUBLIC_HEADERS "hidapi_darwin.h")
 
 add_library(hidapi_darwin
     ${HIDAPI_PUBLIC_HEADERS}

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -71,18 +71,27 @@
 
 # The library
 
+if(HIDAPI_INSTALL_TARGETS)
+    include(GNUInstallDirs)
+endif()
+
 add_library(hidapi_include INTERFACE)
 target_include_directories(hidapi_include INTERFACE
     "$<BUILD_INTERFACE:${PROJECT_ROOT}/hidapi>"
-    "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/hidapi>"
 )
+if(APPLE AND CMAKE_FRAMEWORK)
+    # FIXME: https://github.com/libusb/hidapi/issues/492: it is untrivial to set the include path for Framework correctly
+else()
+    target_include_directories(hidapi_include INTERFACE
+        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/hidapi>"
+    )
+endif()
 set_target_properties(hidapi_include PROPERTIES EXPORT_NAME "include")
 set(HIDAPI_PUBLIC_HEADERS "${PROJECT_ROOT}/hidapi/hidapi.h")
 
 add_library(hidapi::include ALIAS hidapi_include)
 
 if(HIDAPI_INSTALL_TARGETS)
-    include(GNUInstallDirs)
     install(TARGETS hidapi_include EXPORT hidapi)
 endif()
 
@@ -148,9 +157,6 @@
             if(NOT TARGET usb-1.0)
                 set(HIDAPI_NEED_EXPORT_LIBUSB TRUE)
             endif()
-            if(NOT HIDAPI_NO_ICONV AND NOT ANDROID AND NOT CMAKE_VERSION VERSION_LESS 3.11)
-                set(HIDAPI_NEED_EXPORT_ICONV TRUE)
-            endif()
         endif()
     elseif(NOT TARGET hidapi_hidraw)
         message(FATAL_ERROR "Select at least one option to build: HIDAPI_WITH_LIBUSB or HIDAPI_WITH_HIDRAW")
@@ -163,7 +169,7 @@
     include(CMakePackageConfigHelpers)
     set(EXPORT_DENERATED_LOCATION "${CMAKE_BINARY_DIR}/export_generated")
     set(EXPORT_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/hidapi")
-    write_basic_package_version_file("${EXPORT_DENERATED_LOCATION}/libhidapi-version.cmake"
+    write_basic_package_version_file("${EXPORT_DENERATED_LOCATION}/hidapi-config-version.cmake"
         COMPATIBILITY SameMajorVersion
     )
     configure_package_config_file("cmake/hidapi-config.cmake.in" "${EXPORT_DENERATED_LOCATION}/hidapi-config.cmake"
@@ -177,7 +183,7 @@
         FILE "libhidapi.cmake"
     )
     install(FILES
-            "${EXPORT_DENERATED_LOCATION}/libhidapi-version.cmake"
+            "${EXPORT_DENERATED_LOCATION}/hidapi-config-version.cmake"
             "${EXPORT_DENERATED_LOCATION}/hidapi-config.cmake"
         DESTINATION "${EXPORT_DESTINATION}"
     )

=== subprojects/hidapi_build_cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3 FATAL_ERROR)
project(hidapi LANGUAGES C)

file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/root")

foreach(ROOT_ELEMENT CMakeLists.txt hidapi src windows linux mac libusb pc VERSION)
  file(COPY "${CMAKE_CURRENT_LIST_DIR}/../../${ROOT_ELEMENT}" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}/root/")
endforeach()

add_subdirectory("${CMAKE_CURRENT_BINARY_DIR}/root" hidapi_root)

=== debian/changelog ===
hidapi (0.13.1-1) unstable; urgency=medium

  * Update to new upstream release 0.13.1
  * Update Standards-Version to 4.6.2

 -- Scott Talbert <swt@techie.net>  Wed, 18 Jan 2023 21:10:23 -0500

## hidapi 0.14.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 if(NOT CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
     add_subdirectory(src)
-    # compatinility with find_package() vs add_subdirectory
+    # compatibility with find_package() vs add_subdirectory
     set(hidapi_VERSION "${hidapi_VERSION}" PARENT_SCOPE)
     return()
 endif()
@@ -49,13 +49,57 @@
 set(HIDAPI_INSTALL_TARGETS ON)
 set(HIDAPI_PRINT_VERSION ON)
 
+set(IS_DEBUG_BUILD OFF)
+if(CMAKE_BUILD_TYPE STREQUAL "Debug")
+    set(IS_DEBUG_BUILD ON)
+endif()
+
+option(HIDAPI_ENABLE_ASAN "Build HIDAPI with ASAN address sanitizer instrumentation" OFF)
+
+if(HIDAPI_ENABLE_ASAN)
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address")
+    if(MSVC)
+        # the default is to have "/INCREMENTAL" which causes a warning when "-fsanitize=address" is present
+        set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /INCREMENTAL:NO")
+        set(CMAKE_SHARED_LINKER_FLAGS_DEBUG "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} /INCREMENTAL:NO")
+        set(CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO} /INCREMENTAL:NO")
+        set(CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO} /INCREMENTAL:NO")
+    endif()
+endif()
+
+if(WIN32)
+    # so far only Windows has tests
+    option(HIDAPI_WITH_TESTS "Build HIDAPI (unit-)tests" ${IS_DEBUG_BUILD})
+else()
+    set(HIDAPI_WITH_TESTS OFF)
+endif()
+
+if(HIDAPI_WITH_TESTS)
+    enable_testing()
+endif()
+
+if(WIN32)
+    option(HIDAPI_BUILD_PP_DATA_DUMP "Build small Windows console application pp_data_dump.exe" ${IS_DEBUG_BUILD})
+endif()
+
 add_subdirectory(src)
 
-set(BUILD_HIDTEST_DEFAULT OFF)
-if(CMAKE_BUILD_TYPE STREQUAL "Debug")
-    set(BUILD_HIDTEST_DEFAULT ON)
-endif()
-option(HIDAPI_BUILD_HIDTEST "Build small console test application hidtest" ${BUILD_HIDTEST_DEFAULT})
+option(HIDAPI_BUILD_HIDTEST "Build small console test application hidtest" ${IS_DEBUG_BUILD})
 if(HIDAPI_BUILD_HIDTEST)
     add_subdirectory(hidtest)
 endif()
+
+if(HIDAPI_ENABLE_ASAN)
+    if(NOT MSVC)
+        # MSVC doesn't recognize those options, other compilers - requiring it
+        foreach(HIDAPI_TARGET hidapi_winapi hidapi_darwin hidapi_hidraw hidapi_libusb hidtest_hidraw hidtest_libusb hidtest)
+            if(TARGET ${HIDAPI_TARGET})
+                if(BUILD_SHARED_LIBS)
+                    target_link_options(${HIDAPI_TARGET} PRIVATE -fsanitize=address)
+                else()
+                    target_link_options(${HIDAPI_TARGET} PUBLIC -fsanitize=address)
+                endif()
+            endif()
+        endforeach()
+    endif()
+endif()

=== libusb/CMakeLists.txt ===
--- 
+++ 
@@ -18,6 +18,69 @@
 
 find_package(Threads REQUIRED)
 target_link_libraries(hidapi_libusb PRIVATE Threads::Threads)
+
+if(HIDAPI_NO_ICONV)
+    target_compile_definitions(hidapi_libusb PRIVATE NO_ICONV)
+else()
+    if(NOT ANDROID)
+        include(CheckCSourceCompiles)
+
+        if(NOT CMAKE_VERSION VERSION_LESS 3.11)
+            message(STATUS "Check for Iconv")
+            find_package(Iconv)
+            if(Iconv_FOUND)
+                if(NOT Iconv_IS_BUILT_IN)
+                    target_link_libraries(hidapi_libusb PRIVATE Iconv::Iconv)
+                    set(CMAKE_REQUIRED_LIBRARIES "Iconv::Iconv")
+                    if(NOT BUILD_SHARED_LIBS)
+                        set(HIDAPI_NEED_EXPORT_ICONV TRUE PARENT_SCOPE)
+                    endif()
+                endif()
+            else()
+                message(STATUS "Iconv Explicitly check '-liconv'")
+                # Sometime the build environment is not setup
+                # in a way CMake can find Iconv on its own by default.
+                # But if we simply link against iconv (-liconv), the build may succeed
+                # due to other compiler/link flags.
+                set(CMAKE_REQUIRED_LIBRARIES "iconv")
+                check_c_source_compiles("
+                    #include <stddef.h>
+                    #include <iconv.h>
+                    int main() {
+                        char *a, *b;
+                        size_t i, j;
+                        iconv_t ic;
+                        ic = iconv_open(\"to\", \"from\");
+                        iconv(ic, &a, &i, &b, &j);
+                        iconv_close(ic);
+                    }
+                    "
+                    Iconv_EXPLICITLY_AT_ENV)
+                if(Iconv_EXPLICITLY_AT_ENV)
+                    message(STATUS "Iconv Explicitly check '-liconv' - Available")
+                    target_link_libraries(hidapi_libusb PRIVATE iconv)
+                else()
+                    message(FATAL_ERROR "Iconv is not found, make sure to provide it in the build environment")
+                endif()
+            endif()
+        else()
+            # otherwise there is 2 options:
+            # 1) iconv is provided by Standard C library and the build will be just fine
+            # 2) The _user_ has to provide additiona compilation options for this project/target
+        endif()
+
+        # check for error: "conflicting types for 'iconv'"
+        check_c_source_compiles("#include<iconv.h>
+            extern size_t iconv (iconv_t cd, const char **inbuf, size_t *inbytesleft, char **outbuf, size_t *outbytesleft);
+            int main() {}"
+        HIDAPI_ICONV_CONST)
+        if(HIDAPI_ICONV_CONST)
+            target_compile_definitions(hidapi_libusb PRIVATE "ICONV_CONST=const")
+        endif()
+    else()
+        # On Android Iconv is disabled on the code level anyway, so no issue;
+    endif()
+endif()
 
 set_target_properties(hidapi_libusb
     PROPERTIES

=== windows/test/CMakeLists.txt ===
add_executable(hid_report_reconstructor_test hid_report_reconstructor_test.c)
set_target_properties(hid_report_reconstructor_test
    PROPERTIES
        C_STANDARD 11
        C_STANDARD_REQUIRED TRUE
)

target_link_libraries(hid_report_reconstructor_test
     PRIVATE hidapi_include hidapi_winapi
)

# Each test case requires 2 files:
# <name>.pp_data - textual representation of HIDP_PREPARSED_DATA;
# <name>_expected.rpt_desc - reconstructed HID Report Descriptor out of .pp_data file;
#
# (Non-required by test):
# <name>_real.dpt_desc - the original report rescriptor used to create a test case;
set(HID_DESCRIPTOR_RECONSTRUCT_TEST_CASES
     046D_C52F_0001_000C
     046D_C52F_0001_FF00
     046D_C52F_0002_0001
     046D_C52F_0002_FF00
     17CC_1130_0000_FF01
     046D_0A37_0001_000C
     046A_0011_0006_0001
     046D_C077_0002_0001
     046D_C283_0004_0001
     046D_B010_0006_0001
     046D_B010_0002_FF00
     046D_B010_0002_0001
     046D_B010_0001_FF00
     046D_B010_0001_000C
     046D_C534_0001_000C
     046D_C534_0001_FF00
     046D_C534_0002_0001
     046D_C534_0002_FF00
     046D_C534_0006_0001
     046D_C534_0080_0001
     047F_C056_0001_000C
     047F_C056_0003_FFA0
     047F_C056_0005_000B
     045E_02FF_0005_0001
)

set(CMAKE_VERSION_SUPPORTS_ENVIRONMENT_MODIFICATION "3.22")

if(HIDAPI_ENABLE_ASAN AND MSVC)
     if(CMAKE_VERSION VERSION_LESS CMAKE_VERSION_SUPPORTS_ENVIRONMENT_MODIFICATION)
          message("CTest/ASAN: Make sure to run ctest from MSVC Command Prompt")
     endif()
endif()

foreach(TEST_CASE ${HID_DESCRIPTOR_RECONSTRUCT_TEST_CASES})
     set(TEST_PP_DATA "${CMAKE_CURRENT_LIST_DIR}/data/${TEST_CASE}.pp_data")
     if(NOT EXISTS "${TEST_PP_DATA}")
          message(FATAL_ERROR "Missing '${TEST_PP_DATA}' file for '${TEST_CASE}' test case")
     endif()
     set(TEST_EXPECTED_DESCRIPTOR "${CMAKE_CURRENT_LIST_DIR}/data/${TEST_CASE}_expected.rpt_desc")
     if(NOT EXISTS "${TEST_EXPECTED_DESCRIPTOR}")
          message(FATAL_ERROR "Missing '${TEST_EXPECTED_DESCRIPTOR}' file for '${TEST_CASE}' test case")
     endif()

     add_test(NAME "WinHidReportReconstructTest_${TEST_CASE}"
          COMMAND hid_report_reconstructor_test "${TEST_PP_DATA}" "${TEST_EXPECTED_DESCRIPTOR}"
          WORKING_DIRECTORY "$<TARGET_FILE_DIR:hidapi_winapi>"
     )
     if(HIDAPI_ENABLE_ASAN)
          if(MSVC)
               if(NOT CMAKE_VERSION VERSION_LESS CMAKE_VERSION_SUPPORTS_ENVIRONMENT_MODIFICATION)
                    get_filename_component(MSVC_BUILD_TOOLS_DIR "${CMAKE_LINKER}" DIRECTORY)
                    set_property(TEST "WinHidReportReconstructTest_${TEST_CASE}" PROPERTY ENVIRONMENT_MODIFICATION "PATH=path_list_append:${MSVC_BUILD_TOOLS_DIR}")
               endif()
          endif()
          set_property(TEST "WinHidReportReconstructTest_${TEST_CASE}" PROPERTY ENVIRONMENT "ASAN_SAVE_DUMPS=AsanDump_${TEST_CASE}.dmp")
     endif()
endforeach()

=== debian/changelog ===
hidapi (0.14.0-1build1) noble; urgency=high

  * No change rebuild for frame pointers (and time_t).

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 18 Apr 2024 19:56:59 +0200

hidapi (0.14.0-1) unstable; urgency=medium

  * Update to new upstream release 0.14.0

 -- Scott Talbert <swt@techie.net>  Thu, 15 Jun 2023 16:41:49 -0400

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: hidapi
 Priority: optional
-Maintainer: Scott Talbert <swt@techie.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Scott Talbert <swt@techie.net>
 Build-Depends: debhelper-compat (= 13), libudev-dev [linux-any], libusb-1.0-0-dev [linux-any], libusb2-dev (>= 10.0-4) [kfreebsd-any], pkg-config
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Section: libs
 Homepage: https://github.com/libusb/hidapi
 Vcs-Git: https://salsa.debian.org/debian/hidapi.git
